install 14 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. comprobarError() {
  11. # Mejora: tratar todos los mensajes de error desde aquí
  12. printf "SIN HACER...\n"
  13. }
  14. OSInfo() {
  15. #printf "Detectando SO..."
  16. OS=$(uname -s)
  17. if [ $OS = "Linux" ]; then
  18. OS="GNU/Linux"
  19. if [ -f /etc/os-release ]; then
  20. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  21. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  22. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  23. for i in $ID_LIKE; do
  24. #printf "$i\n"
  25. case $i in
  26. debian|ubuntu)
  27. debianOS=true
  28. break
  29. ;;
  30. rhel|fedora)
  31. rhelOS=true
  32. break
  33. ;;
  34. *)
  35. debianOS=false
  36. rhelOS=false
  37. ;;
  38. esac
  39. done
  40. elif [ -f /etc/debian-version ]; then
  41. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  42. DIST="Debian"
  43. REV=""
  44. ID_LIKE="debian"
  45. debianOS=true
  46. elif [ -f /etc/redhat-release ]; then
  47. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  48. DIST="Red-Hat"
  49. REV=""
  50. ID_LIKE="rhel"
  51. rhelOS=true
  52. else
  53. # Other Linux (No Soportado)
  54. DIST=""
  55. REV=""
  56. ID_LIKE=""
  57. fi
  58. else
  59. # UNIX, OS X, ... (No Soportado)
  60. DIST=$OS
  61. REV=""
  62. fi
  63. #printf " $OS $DIST $REV\n"
  64. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  65. }
  66. comprobarRoot() {
  67. if [ $(id -u) -ne 0 ]; then
  68. printf "ERROR:\tEs necesario ser root ('sudo $0').\n"
  69. exit 1
  70. fi
  71. }
  72. comprobarDependencias() {
  73. # Comprobamos whiptail
  74. which whiptail > /dev/null 2>&1
  75. if [ $? -ne 0 ];then
  76. printf "ERROR:\t'whiptail' no disponible.\n"
  77. exit 1
  78. fi
  79. # Comprobamos hostnamectl
  80. which hostnamectl > /dev/null 2>&1
  81. if [ $? -ne 0 ];then
  82. printf "ERROR:\t'hostnamectl' no disponible.\n"
  83. exit 1
  84. fi
  85. if [ $debianOS = true ];then
  86. # Comprobamos apt-get
  87. which apt-get > /dev/null 2>&1
  88. if [ $? -ne 0 ]; then
  89. printf "ERROR:\t'apt-get' no está disponible.\n"
  90. exit 1
  91. fi
  92. # Actualizamos base de datos del repositorio
  93. printf "Actualizando repositorio APT..."
  94. result=$(apt-get -q -y update)
  95. if [ $? -ne 0 ]; then
  96. printf "\nERROR:\tImposible actualizar repositorio.\n"
  97. printf "Detalles:\n$result\n"
  98. exit 1
  99. fi
  100. printf " OK.\n"
  101. # Comprobamos Firewall (ufw)
  102. which ufw > /dev/null 2>&1
  103. if [ $? -ne 0 ]; then
  104. printf "ERROR:\t'ufw' no disponible.\n"
  105. exit 1
  106. fi
  107. fi
  108. if [ $rhelOS = true ]; then
  109. # Comprobamos yum
  110. which yum > /dev/null 2>&1
  111. if [ $? -ne 0 ]; then
  112. printf "ERROR:\t'yum' no está disponible.\n"
  113. exit 1
  114. fi
  115. # Actualizamos base de datos del repositorio
  116. printf "Actualizando repositorio YUM..."
  117. result=$(yum -y makecache 2>&1)
  118. if [ $? -ne 0 ]; then
  119. printf "\nERROR:\tImposible actualizar repositorio.\n"
  120. printf "Detalles:\n$result\n"
  121. exit 1
  122. fi
  123. printf " OK.\n"
  124. # Comprobamos Firewall (firewall-cmd)
  125. which firewall-cmd > /dev/null 2>&1
  126. if [ $? -ne 0 ]; then
  127. printf "ERROR:\t'firewall-cmd' no disponible.\n"
  128. exit 1
  129. fi
  130. fi
  131. }
  132. inicializarVariables() {
  133. debianOS=false
  134. rhelOS=false
  135. apacheOn=false
  136. nginxOn=false
  137. mySQLOn=false
  138. mariaDBOn=false
  139. phpOn=false
  140. mediaWikiOn=false
  141. moodleOn=false
  142. actualizacionesOn=false
  143. }
  144. instalacionExpress() {
  145. apacheOn=true
  146. mariaDBOn=true
  147. phpOn=true
  148. mediaWikiOn=true
  149. moodleOn=true
  150. actualizacionesOn=true
  151. }
  152. mostrarBienvenida() {
  153. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  154. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" 20 70 --ok-button "Salir"
  155. exit 1
  156. fi
  157. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" 20 70 --yes-button "Continuar" --no-button "Salir"
  158. if [ $? -ne 0 ]; then
  159. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  160. exit 2
  161. fi
  162. }
  163. mostrarExpress() {
  164. express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y actualizaciones automáticas.\nSeleccione el tipo de instalación que desee:" 20 70 2 \
  165. "Express" "Instalación rápida" ON \
  166. "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
  167. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  168. if [ $? -ne 0 ]; then
  169. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  170. exit 2
  171. fi
  172. case $express in
  173. Express)
  174. instalacionExpress
  175. # DECIDIR QUÉ OPCIONES SON LAS MÍNIMAS
  176. ;;
  177. Avanzada)
  178. mostrarAvanzada
  179. ;;
  180. *)
  181. printf "ERROR:\tError interno (selección express).\n"
  182. exit 1
  183. ;;
  184. esac
  185. }
  186. mostrarAvanzada() {
  187. componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" 20 70 7 \
  188. "WebServer" "Instalar servidor web http/https" ON \
  189. "Database" "Instalar una base de datos SQL" ON \
  190. "PHP" "Instala PHP7" ON \
  191. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  192. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  193. "Moodle" "Instalar campus virtual con Moodle" ON \
  194. "Actualizaciones" "Programar actualizaciones automáticas" ON \
  195. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  196. if [ $? -ne 0 ]; then
  197. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  198. exit 2
  199. fi
  200. # Mejora: autodetección de componentes ya instalados
  201. for i in $componentes; do
  202. case $i in
  203. \"WebServer\")
  204. mostrarWebServer
  205. ;;
  206. \"Database\")
  207. mostrarDatabase
  208. ;;
  209. \"PHP\")
  210. phpOn=true
  211. ;;
  212. \"SSL/TLS\")
  213. # 2 Opciones: Let's Encrypt o Autofirmado
  214. ;;
  215. \"MediaWiki\")
  216. mediaWikiOn=true
  217. ;;
  218. \"Moodle\")
  219. moodleOn=true
  220. ;;
  221. \"Actualizaciones\")
  222. actualizacionesOn=true
  223. ;;
  224. *)
  225. printf "ERROR:\tError interno (selección de componentes).\n"
  226. exit 1
  227. ;;
  228. esac
  229. done
  230. }
  231. mostrarWebServer() {
  232. webServer=$(whiptail --title "SERVIDOR WEB" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el servidor web que quieres usar:" 20 70 2 \
  233. "Apache" "Instalar el servidor web Apache2" ON \
  234. "Nginx" "Instalar el servidor web Nginx" OFF \
  235. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  236. if [ $? -ne 0 ]; then
  237. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  238. exit 2
  239. fi
  240. case $webServer in
  241. Apache)
  242. apacheOn=true
  243. ;;
  244. Nginx)
  245. nginxOn=true
  246. ;;
  247. *)
  248. printf "ERROR:\tError interno (selección de web server).\n"
  249. exit 1
  250. ;;
  251. esac
  252. # Otras opciones (FQDN)
  253. establecerFQDN
  254. }
  255. establecerFQDN() {
  256. while [ -z $hostname ]; do
  257. hostname=$(whiptail --title "FQDN" --inputbox "El nombre de dominio principal (FQDN) de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" 20 70 --ok-button "Cambiar" --cancel-button "No Cambiar" 3>&1 1>&2 2>&3)
  258. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  259. hostnamectl set-hostname $hostname
  260. else
  261. hostname=$(hostname)
  262. fi
  263. done
  264. #printf "\nHostname: $hostname\n"
  265. }
  266. instalarApache() {
  267. if [ $debianOS = true ];then
  268. result=$(apt-get -q -y install apache2 2>&1)
  269. if [ $? -ne 0 ]; then
  270. printf "\nERROR:\tError al instalar Apache2.\n"
  271. printf "Detalles:\n$result\n"
  272. exit 1
  273. fi
  274. elif [ $rhelOS = true ]; then
  275. result=$(yum -y install httpd 2>&1)
  276. if [ $? -ne 0 ]; then
  277. printf "\nERROR:\tError al instalar Apache2.\n"
  278. printf "Detalles:\n$result\n"
  279. exit 1
  280. fi
  281. else
  282. printf "\nERROR:\tError interno (instalación Apache2).\n"
  283. exit 1
  284. fi
  285. }
  286. instalarNginx() {
  287. if [ $debianOS = true ];then
  288. result=$(apt-get -q -y install nginx 2>&1)
  289. if [ $? -ne 0 ]; then
  290. printf "\nERROR:\tError al instalar Nginx.\n"
  291. printf "Detalles:\n$result\n"
  292. exit 1
  293. fi
  294. elif [ $rhelOS = true ]; then
  295. # Hay que instalar primero otro repositorio
  296. result=$(yum -y install epel-release)
  297. if [ $? -ne 0 ]; then
  298. printf "\nERROR:\tError al intalar repositorio 'epel-release'.\n"
  299. printf "Detalles:\n$result\n"
  300. exit 1
  301. fi
  302. result=$(yum -y install nginx 2>&1)
  303. if [ $? -ne 0 ]; then
  304. printf "\nERROR:\tError al instalar Nginx.\n"
  305. printf "Detalles:\n$result\n"
  306. exit 1
  307. fi
  308. else
  309. printf "\nERROR:\tError interno (instalación Nginx).\n"
  310. exit 1
  311. fi
  312. }
  313. mostrarDatabase() {
  314. if [ $debianOS = true ]; then
  315. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" 20 70 2 \
  316. "MySQL" "Instalar la base de datos MySQL (no uso comercial)" ON \
  317. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" OFF \
  318. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  319. if [ $? -ne 0 ]; then
  320. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  321. exit 2
  322. fi
  323. case $database in
  324. MySQL)
  325. mySQLOn=true
  326. ;;
  327. MariaDB)
  328. mariaDBOn=true
  329. ;;
  330. *)
  331. printf "ERROR:\tError interno (selección de base de datos).\n"
  332. exit 1
  333. ;;
  334. esac
  335. elif [ $rhelOS = true ]; then
  336. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." 20 70 --yes-button "Continuar" --no-button "Salir"
  337. if [ $? -ne 0 ]; then
  338. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  339. exit 2
  340. fi
  341. mariaDBOn=true
  342. else
  343. printf "ERROR:\tError interno (instalación Base de Datos).\n"
  344. exit 1
  345. fi
  346. # Otras opciones (contraseña)
  347. leerSQLPasswd
  348. }
  349. leerSQLPasswd() {
  350. control=false
  351. # Leemos la contreseña (stdin) y confirmamos
  352. while [ $control = false ]; do
  353. sqlPasswd=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Introduzca la contraseña para el usuario 'root' de la base de datos:" 20 70 --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  354. if [ $? -ne 0 ]; then
  355. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  356. exit 2
  357. fi
  358. sqlPasswd2=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Confirme la contraseña:" 20 70 --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  359. if [ $? -ne 0 ];then
  360. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  361. exit 2
  362. fi
  363. if [ $sqlPasswd = $sqlPasswd2 ];then
  364. control=true
  365. fi
  366. done
  367. #printf "SQL Password: $sqlPasswd\n"
  368. unset control sqlPasswd2
  369. }
  370. establecerSQLPasswd() {
  371. # Establecemos SQL root passwd y securizamos BD (mysql_secure_installation)
  372. printf "SIN HACER...\n"
  373. }
  374. instalarMySQL() {
  375. if [ $debianOS = true ];then
  376. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  377. if [ $? -ne 0 ]; then
  378. printf "\nERROR:\tError al instalar MySQL.\n"
  379. printf "Detalles:\n$result\n"
  380. exit 1
  381. fi
  382. elif [ $rhelOS = true ]; then
  383. # MySQL no disponible en RHEL. 2 opciones:
  384. # 1) Instalar un repositorio adicional
  385. # 2) No instalar MySQL en distribuciones RHEL
  386. printf "\nERROR:\tRHEL no incluye MySQL en sus repositorios.\n"
  387. exit 1
  388. else
  389. printf "\nERROR:\tError interno (instalación MySQL).\n"
  390. exit 1
  391. fi
  392. }
  393. instalarMariaDB() {
  394. if [ $debianOS = true ];then
  395. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  396. if [ $? -ne 0 ]; then
  397. printf "\nERROR:\tError al instalar MariaDB.\n"
  398. printf "Detalles:\n$result\n"
  399. exit 1
  400. fi
  401. elif [ $rhelOS = true ]; then
  402. result=$(yum -y install mariadb-server 2>&1)
  403. if [ $? -ne 0 ]; then
  404. printf "\nERROR:\tError al instalar MariaDB.\n"
  405. printf "Detalles:\n$result\n"
  406. exit 1
  407. fi
  408. else
  409. printf "\nERROR:\tError interno (instalación MariaDB).\n"
  410. exit 1
  411. fi
  412. }
  413. # Comprobación del sistema e inicialización
  414. comprobarRoot
  415. inicializarVariables
  416. OSInfo
  417. comprobarDependencias
  418. # Bienvenida
  419. mostrarBienvenida
  420. # Selección de componentes (express vs avanzada)
  421. mostrarExpress
  422. # Pre-configuración
  423. # Habilitar cortafuegos -> PROBLEMA: se corta la conexión ssh
  424. # Instalación
  425. # FALTA: whiptail --gauge -> Más bonito
  426. # Servidor Web
  427. if [ $apacheOn = true ]; then
  428. printf "Instalando Web Server Apache..."
  429. instalarApache
  430. printf " OK.\n"
  431. elif [ $nginxOn = true ]; then
  432. printf "Instalando Web Server Nginx..."
  433. instalarNginx
  434. printf " OK.\n"
  435. fi
  436. # Base de Datos
  437. if [ $mySQLOn = true ]; then
  438. printf "Instalando Base de Datos MySQL..."
  439. instalarMySQL
  440. printf " OK.\n"
  441. elif [ $mariaDBOn = true ]; then
  442. printf "Instalando Base de Datos MariaDB..."
  443. instalarMariaDB
  444. printf " OK.\n"
  445. fi
  446. # PHP
  447. if [ $phpOn = true ]; then
  448. printf "Instalando PHP-7..."
  449. printf " OK.\n"
  450. fi
  451. # SSL/TLS
  452. # Falta por implementar
  453. # MediaWiki
  454. if [ $mediaWikiOn = true ]; then
  455. printf "Instalando MediaWiki..."
  456. printf " OK.\n"
  457. fi
  458. # Moodle
  459. if [ $moodleOn = true ]; then
  460. printf "Instalando Moodle..."
  461. printf " OK.\n"
  462. fi
  463. # Configuración
  464. # Configuración Apache
  465. # Virtual Hosts
  466. # Configuración Database
  467. # Establecer Contrasñea y configuración Segura
  468. if [ $mySQLOn = true ] || [ $mariaDBOn = true ];then
  469. establecerSQLPasswd
  470. fi
  471. # Configuración PHP
  472. # cgi.fix_pathinfo=0
  473. # Configurar máximo de subida de archivos
  474. # Configuración MediWiki
  475. # Configuración Moodle
  476. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  477. # Añadir reglas del cortafuegos
  478. # Configuración SSL/TLS
  479. # Generar certificados
  480. # Configurar certificados
  481. # Configurar actualizaciones
  482. if [ $actualizacionesOn = true ]; then
  483. printf "Configurando actualizaciones automáticas..."
  484. # CRONTAB
  485. printf " OK.\n"
  486. fi
  487. # Autodestrucción
  488. {
  489. for i in $(seq 0 5 50); do
  490. sleep 0.1
  491. echo $i
  492. done
  493. } | whiptail --gauge "Autodestrucción..." 7 70 0
  494. {
  495. for i in $(seq 50 5 100); do
  496. sleep 0.1
  497. echo $i
  498. done
  499. } | whiptail --gauge "Autopulverización..." 7 70 50